﻿using System;
using System.Globalization;
using System.Windows.Data;
using System.Windows.Markup;

namespace Sandbox
{
    public class NumberFormatConverter : MarkupExtension, IMultiValueConverter
    {
        public static NumberFormatConverter Instance { private set; get; }

        static NumberFormatConverter()
        {
            Instance = new NumberFormatConverter();
        }

        public override object ProvideValue(IServiceProvider serviceProvider_)
        {
            return Instance;
        }

        #region Implementation of IMultiValueConverter

        public object Convert(object[] values, Type targetType, object parameter, CultureInfo culture)
        {
            return values[0].ToString();
        }

        public object[] ConvertBack(object value, Type[] targetTypes, object parameter, CultureInfo culture)
        {
            var result = 0m;
            if (value != null)
            {
                decimal.TryParse(value.ToString(), out result);
            }
            return new object[] { result };
        }

        #endregion
    }
}
